summaryrefslogtreecommitdiffstats
path: root/system/spl-solaris
diff options
context:
space:
mode:
Diffstat (limited to 'system/spl-solaris')
-rw-r--r--system/spl-solaris/README21
-rw-r--r--system/spl-solaris/doinst.sh3
-rw-r--r--system/spl-solaris/slack-desc19
-rw-r--r--system/spl-solaris/spl-solaris.SlackBuild109
-rw-r--r--system/spl-solaris/spl-solaris.info10
5 files changed, 162 insertions, 0 deletions
diff --git a/system/spl-solaris/README b/system/spl-solaris/README
new file mode 100644
index 0000000000..cde5bc628d
--- /dev/null
+++ b/system/spl-solaris/README
@@ -0,0 +1,21 @@
+The Solaris Porting Layer (SPL) is a Linux kernel module which
+provides many of the Solaris kernel APIs.
+This shim layer makes it possible to run Solaris kernel code in the
+Linux kernel with relatively minimal modification.
+
+This can be particularly useful when you want to track upstream
+Solaris development closely and do not want the overhead of
+maintaining a large patch which converts Solaris primitives to Linux
+primitives.
+
+You need this if you want to run ZFS on Linux.
+
+NOTE: You'll need the kernel source code to be able to compile this.
+This package is kernel dependent, so you'll need to recompile it for
+every new kernel you choose to run.
+
+If you don't have a /usr/src/linux symlink pointing to your real
+kernel directory (the script looks for it there by default), specify
+your kernel source destination by
+
+ LINUXPATH=<path to your kernel source> ./spl-solaris.SlackBuild
diff --git a/system/spl-solaris/doinst.sh b/system/spl-solaris/doinst.sh
new file mode 100644
index 0000000000..ddc5b85c14
--- /dev/null
+++ b/system/spl-solaris/doinst.sh
@@ -0,0 +1,3 @@
+if [ -x /sbin/depmod ]; then
+ chroot . /sbin/depmod -a >/dev/null 2>&1
+fi
diff --git a/system/spl-solaris/slack-desc b/system/spl-solaris/slack-desc
new file mode 100644
index 0000000000..eb44c8f743
--- /dev/null
+++ b/system/spl-solaris/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+spl-solaris: spl-solaris (solaris kernel API for linux)
+spl-solaris:
+spl-solaris: The Solaris Porting Layer (SPL) is a Linux kernel module
+spl-solaris: which provides many of the Solaris kernel APIs.
+spl-solaris: This shim layer makes it possible to run Solaris kernel code
+spl-solaris: in the Linux kernel with relatively minimal modification.
+spl-solaris:
+spl-solaris: homepage: http://zfsonlinux.org
+spl-solaris:
+spl-solaris:
+spl-solaris:
diff --git a/system/spl-solaris/spl-solaris.SlackBuild b/system/spl-solaris/spl-solaris.SlackBuild
new file mode 100644
index 0000000000..ada8745eb1
--- /dev/null
+++ b/system/spl-solaris/spl-solaris.SlackBuild
@@ -0,0 +1,109 @@
+#!/bin/sh
+
+# Slackware build script for spl-solaris
+
+# Copyright 2013 Petr Hejl - Czech Republic
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Modified by the SlackBuilds.org project
+
+PRGNAM=spl-solaris
+SRCNAM=spl
+VERSION=${VERSION:-0.6.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+KERN=$(uname -r)
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -fr $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+if [ -z $LINUXPATH ]; then
+ LINUXPATH=/usr/src/linux
+fi
+
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --sbindir=/sbin \
+ --includedir=/usr/include \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --with-linux=$LINUXPATH \
+ --with-linux-obj=$LINUXPATH \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS COPYING DISCLAIMER $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-${VERSION}_${KERN}-$ARCH-$BUILD$TAG.${PKGTYPE:-txz}
diff --git a/system/spl-solaris/spl-solaris.info b/system/spl-solaris/spl-solaris.info
new file mode 100644
index 0000000000..faff292265
--- /dev/null
+++ b/system/spl-solaris/spl-solaris.info
@@ -0,0 +1,10 @@
+PRGNAM="spl-solaris"
+VERSION="0.6.2"
+HOMEPAGE="http://zfsonlinux.org"
+DOWNLOAD="http://archive.zfsonlinux.org/downloads/zfsonlinux/spl/spl-0.6.2.tar.gz"
+MD5SUM="f00535bf89a7fde0e08f44a14a1f1e03"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="%README%"
+MAINTAINER="Petr Hejl"
+EMAIL="silenost01@seznam.cz"